(in-package :om)

; Variable Declarations

; GLOBALE VARIABLEN SETZEN
; knnne auch auf NIL initialisiert werden


(defmethod! harmon-database (pitch-set-list instr0 &key instr1 instr2 instr3 (register-list '(0 1200 2400 4800)))
:icon 133
:indoc '("a list of lists of intervals respective to a base not in midi-cents" "range-list with the lowest and highest note of the instrument in midi-cents" "range-list with the lowest and highest note of the instrument in midi-cents" "range-list with the lowest and highest note of the instrument in midi-cents" "range-list with the lowest and highest note of the instrument in midi-cents" "list of intervals based on the virtual fundamental which defines the <octave> for register-transposition")

:numouts 1

:doc "creates a list of chords, that contains all possible transpositions & permutations of the given pitch-sets"
(progn 
  (defparameter *total-range*  
    (list 
     (x-append
      (list-min (remove nil (list instr0 instr1 instr2 instr3)))
      (list-max (remove nil (list instr0 instr1 instr2 instr3)))
      )
     (remove nil (list instr0 instr1 instr2 instr3))
     )
    )


(defparameter *pitch-set-list* pitch-set-list)
  

  (let ((limited-pitch-set-list
         (loop for item in *pitch-set-list*
               collect (if (> (length item) (length (second *total-range*))) (print (first-n item (length (second *total-range*)))) 
                         (if (< (length item) (length (second *total-range*))) (values (append item (repeat-n nil (- (length (second *total-range*)) (length item)))))
                           (values item))))))
    (defparameter *pitch-classes* limited-pitch-set-list))
  
  (defparameter *pitch-set-lists* (remove-dup (loop for p in *pitch-classes* collect (permutations p)) #'equal 1))
  *pitch-set-lists*
  
  (defparameter *harmon-material* (loop for r in *pitch-set-lists* collect
                                        (loop for item in r
                                              collect
                                              (mapcar (lambda (it) (om+ it item))
                                                      
                                                      (arithm-ser (list-min (first *total-range*)) (list-max (first *total-range*)) 100)))))
  
  (remove nil 
          (loop for a in 
                (loop for q in 
                      (remove-dup (flat (let ((pitches&octaves 
                                               (loop for x in *harmon-material*
                                                     for y in (loop for a in *harmon-material* collect 
                                                                    
                                                                    (remove-dup (flat (mapcar (lambda (this) (permutations this)) (flat (loop for x in register-list collect
                                                                                                                                              (let ((loop-list (arithm-ser 1 (length (caar a)) 1)))
                                                                                                                                                
                                                                                                                                                (mapcar (lambda (it) (append (repeat-n x it) (repeat-n 0 (- (last-elem loop-list) it)))) loop-list))) 1)) 1) #'equal 1))
                                                     
                                                     
                                                     collect (list (flat x 1) y))))
                                          
                                          
                                          (loop for z in pitches&octaves collect
                                                
                                                (loop for w in (first z) collect
                                                      (mapcar (lambda (item) (om+ w item)) (second z))))) 2)  #'equal 1) 
                      collect (loop for l in q 
                                    for m in (second *total-range*)
                                    collect
                                    (cond ((equal l nil) (values l)) ((and (<= l (second m)) (>= l (first m))) (values l)) (t (values "not")))) 
                      
                      ) collect (if (find "not" a :test 'equal) (values nil) (values a))))))




